From e05de8796e16da8c388f8353b7f9c41978ef9355 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Jan 03 2021 02:21:06 +0000
Subject: [PATCH 1997/2232] Move template class workaround to implementation files only


---

diff --git a/gen/src/write.rs b/gen/src/write.rs
index 609814c..c7c9dc7 100644
--- a/gen/src/write.rs
+++ b/gen/src/write.rs
@@ -121,23 +121,25 @@ fn write_data_structures<'a>(out: &mut OutFile<'a>, apis: &'a [Api]) {
 
     out.set_namespace(Default::default());
 
-    // MSVC workaround for "C linkage function cannot return C++ class" error.
-    // Apparently the compiler fails to perform implicit instantiations as part
-    // of an extern declaration. Instead we instantiate explicitly.
-    // See https://stackoverflow.com/a/57429504/6086311.
-    out.next_section();
-    let mut slice_in_return_position = OrderedSet::new();
-    for api in apis {
-        if let Api::CxxFunction(efn) | Api::RustFunction(efn) = api {
-            if let Some(ty @ Type::SliceRef(_)) = &efn.ret {
-                slice_in_return_position.insert(ty);
+    if !out.header {
+        // MSVC workaround for "C linkage function cannot return C++ class" error.
+        // Apparently the compiler fails to perform implicit instantiations as part
+        // of an extern declaration return type. Instead we instantiate explicitly.
+        // See https://stackoverflow.com/a/57429504/6086311.
+        out.next_section();
+        let mut slice_in_return_position = OrderedSet::new();
+        for api in apis {
+            if let Api::CxxFunction(efn) | Api::RustFunction(efn) = api {
+                if let Some(ty @ Type::SliceRef(_)) = &efn.ret {
+                    slice_in_return_position.insert(ty);
+                }
             }
         }
-    }
-    for ty in &slice_in_return_position {
-        write!(out, "template class ");
-        write_type(out, ty);
-        writeln!(out, ";");
+        for ty in &slice_in_return_position {
+            write!(out, "template class ");
+            write_type(out, ty);
+            writeln!(out, ";");
+        }
     }
 
     out.next_section();
diff --git a/tests/ffi/tests.cc b/tests/ffi/tests.cc
index 548ad13..302944a 100644
--- a/tests/ffi/tests.cc
+++ b/tests/ffi/tests.cc
@@ -849,6 +849,9 @@ std::unique_ptr<I> ns_c_return_unique_ptr_ns() {
 // > definition) of each of its non-inherited non-template members that has not
 // > been previously explicitly specialized in the translation unit.
 template class rust::Box<tests::Shared>;
+template class rust::Slice<const char>;
+template class rust::Slice<const uint8_t>;
+template class rust::Slice<uint8_t>;
 template class rust::Slice<const tests::Shared>;
 template class rust::Slice<tests::Shared>;
 template class rust::Slice<const tests::R>;

